import { make } from "./util";
import icon from "./icon.svg";
import "./index.css";

export default class HighlightBlockTune {
  static get isTune() {
    return true;
  }

  constructor({ api, data, config, block }) {
    this.api = api;
    this.block = block;
    this.config = config;
    this.data = data || { highlight: false };

    this.CSS = {
      highlight: "ce-highlight-block",
    };
  }

  wrap(blockContent) {
    this.wrapper = make("div");
    this.wrapper.classList.toggle(this.CSS.highlight, this.data.highlight);
    this.wrapper.append(blockContent);

    return this.wrapper;
  }

  render() {
    const button = make("button", this.api.styles.settingsButton, {
      innerHTML: icon,
      type: "button",
    });

    button.classList.toggle(this.api.styles.settingsButtonActive, this.data.highlight);
    button.addEventListener("click", () => {
      this.data.highlight = !this.data.highlight;
      this.wrapper.classList.toggle(this.CSS.highlight, this.data.highlight);
      button.classList.toggle(this.api.styles.settingsButtonActive, this.data.highlight);
    });

    return button;
  }

  save() {
    return this.data;
  }
}
